 // steuer.js lokal in steuer.html verwendet
 
  // Kontext-OK wird in Kontextpruefung gesetzt
  if (KONTEXT_OK)
  {

       // Bilder einlesen und IMAGE-Objekten zuweisen
       img_ok   = new Array();
       img_ok2  = new Array();
       img_fehl = new Array();
       img_aufdecken = new Array();

       img_ok[0] = new Image();
       img_ok[0].src = "b_ok_off.gif";
       img_ok[1] = new Image();
       img_ok[1].src = "b_ok_low.gif";
       img_ok[2] = new Image();
       img_ok[2].src = "b_ok_high.gif";

       img_ok2[0] = new Image();
       img_ok2[0].src = "b_ok2_off.gif";
       img_ok2[1] = new Image();
       img_ok2[1].src = "b_ok2_low.gif";
       img_ok2[2] = new Image();
       img_ok2[2].src = "b_ok2_high.gif";

       img_fehl[0] = new Image();
       img_fehl[0].src = "b_ueben_off.gif";
       img_fehl[1] = new Image();
       img_fehl[1].src = "b_ueben_low.gif";
       img_fehl[2] = new Image();
       img_fehl[2].src = "b_ueben_high.gif";

       img_aufdecken[0] = new Image();
       img_aufdecken[0].src = "b_antwort_off.gif";
       img_aufdecken[1] = new Image();
       img_aufdecken[1].src = "b_antwort_low.gif";
       img_aufdecken[2] = new Image();
       img_aufdecken[2].src = "b_antwort_high.gif";


	   // Array fr die aktuelle Lektion anlegen
	   //
	   // Initial werden die Fragen im Array gemischt und dann abgefragt.
	   // Wenn eine Frage ausreichend oft richtig beantwortet wurde,
	   // wird sie an das Ende der Liste gestellt, so dass am Anfang der
	   // Liste die noch zu beantwortenden Fragen stehen.
	   uebung_anz_fragen         = 0;
	   uebung_frage_nr           = new Array();
	   uebung_frage_lektion      = new Array();
	   uebung_frage_anz_gestellt = new Array();
	   uebung_frage_anz_richtig  = new Array();
	   uebung_fragen_offen       = 0;

	   anz_richtige_zum_abhaken  = parent.NaviFrame.UEB_ANZ_RICHTIGE_ZUM_ABHAKEN;


	   // Dialog-Status initialisieren
	   dialog_status = "UNDEFINIERT"
   }

   // Schreiben in Log-Window zum Debuggen
   function logwin(logtext)
   {
      var logwin = window.open("","LogWindow",
                    "scrollbars=yes,resizable=yes,toolbar=no,location=no,width=700,height=500");
      logwin.document.writeln(logtext + "<BR>");
   }


   function initialisierung()
   {
      var info;

      // Fehlerbehandlung
      if (document.frame_ok == false)
      {
         // Raus aus der Initialisierung!
         return;
      }

      // bernehmen der bungsparameter fr den aktuellen Aufruf
      // Initialsierung wird nur dann ausgefhrt, wenn ber die
      // Navi-Bar eine Lektion ausgewhlt wurde.
      var ueb_ix        = parent.NaviFrame.UEBUNGS_INDEX;

      // Damit es bei Reload kein Kuddelmuddel gibt (Navi wird initialisiert!)
      // erfolgt ein zurcksetzen!
      switch (ueb_ix)
      {
	      case 0:
	        parent.SteuerFrame.location.href = "about.html";
           parent.TitelFrame.location.href  = "../titel.html";
   	     break;

   	   case 99:

            if (anz_richtige_zum_abhaken > 1 && parent.NaviFrame.UEB_ANZ_RICHTIGE_IN_FOLGE)
            {
               info = "hintereinander ";
            } else {
               info = "";
            }

            // Je nach Trainer wird folgende Funktion implementiert!
            bogen_name = fragen_fuer_pruefung_zusammenstellen();

            fragen_initialisieren(uebung_anz_fragen);

            if (uebung_fragen_offen > 0)
            {
               alert(bogen_name + "\n\n" +
                  "- Eine Prfungsbogen mit " + uebung_anz_fragen + " Fragen wurde zusammengestellt.\n" +
		            "- Jede Frage muss " + anz_richtige_zum_abhaken + " mal " + info + "richtig beantwortet werden, " +
		            "damit sie als bestanden markiert wird.");

               akt_frage = 0;
   	         akt_teil_name = "Prfungsbogen";
   	         frage_stellen(); // Jetzt gehts los....
   	      } else {
   	         alert("Aufgrund der Parameter konnten keine Fragen fr den Bogen ausgewhlt werden.");
   	      }
   	      break;

   	   default:
            akt_teil_name = parent.NaviFrame.UEB_NAME[ueb_ix];
            akt_teil_von  = parent.NaviFrame.UEB_NR_VON[ueb_ix];
            akt_teil_bis  = parent.NaviFrame.UEB_NR_BIS[ueb_ix];
           

            akt_frage  = 0;

         
            fragen_zur_lektion_initialisieren();
            
            
            if (uebung_fragen_offen > 0)
            {
            
               info = "Aktueller bungsteil ist '" + akt_teil_name + "' mit " + 
                      (akt_teil_bis - akt_teil_von + 1) + " Fragen zum Thema.\n\n" + 
                      ueb_parm_info();
            
               alert(info);// Meldung an Anwender
         
               if (parent.NaviFrame.UEB_FRAGEN_MISCHEN)
               {
                  verbleibende_fragen_mischen(); // Erstes Mischen
               }
               frage_stellen(); // So gehts los.
            } else {
               // Kein Fragen von Prfungsbgen fr die Lektion vorhanden....
   	         alert("Die Lektion enthlt keine Fragen, die auf Prfungsbgen vorkommen.");
              
            }
            
      }
   }

   function ueb_parm_info()
   {
      // Generiert einen String zur Ausgabe in der alert-Anweisung, der Information
      // ber die gesetzten Parameter ausgibt.
      var info = "";
      if (parent.NaviFrame.UEB_PRUEF_FRAGEN_ONLY) 
      {
         // ggf. sind alle Fragen einer bung auch auf irgendwelchen Bgen vorhanden
         var ueb_ix        = parent.NaviFrame.UEBUNGS_INDEX;
         if (parent.NaviFrame.UEB_NR_BIS[ueb_ix] - parent.NaviFrame.UEB_NR_VON[ueb_ix] + 1 == uebung_anz_fragen)
         {
            info = "- Es werden alle " + uebung_anz_fragen + " Fragen zum Thema gestellt, da" +
                   " alle Fragen auch auf Prfungsbgen vorkommen.\n"
         } else {
            info = info + "- Es werden nur die " + uebung_anz_fragen +" auf Prfungsbgen vorkommenden Fragen gestellt.\n";
         }
      } else {
         info = info + "- Es werden alle " + uebung_anz_fragen + " Fragen zum Thema gestellt.\n";
      }
         
      if (anz_richtige_zum_abhaken > 1 && parent.NaviFrame.UEB_ANZ_RICHTIGE_IN_FOLGE)
      {
         info = info + "- Jede Frage muss " + anz_richtige_zum_abhaken + " mal hintereinander richtig beantwortet werden, ";
      } else {
         info = info + "- Jede Frage muss " + anz_richtige_zum_abhaken + " mal richtig beantwortet werden, ";
      }
               
      info = info + "damit sie als bestanden markiert wird.";
      
      return info;
   }      

   function toggle_ok(imgName, num)
   {
      // Nur Umschalten, wenn Button aktiv ist
      if (dialog_status == "AUSWERTEN")
	  {
         imgName.src   = img_ok[num].src;
      } else {
         imgName.src   = img_ok[0].src;
      }
   }

   function toggle_ok2(imgName, num)
   {
      // Nur Umschalten, wenn Button aktiv ist
      if (dialog_status == "AUSWERTEN")
	  {
         imgName.src = img_ok2[num].src;
      } else {
         imgName.src = img_ok2[0].src;
      }
   }

   function toggle_fehl(imgName, num)
   {
      // Nur Umschalten, wenn Button aktiv ist
      if (dialog_status == "AUSWERTEN")
	  {
         imgName.src = img_fehl[num].src;
      } else {
         imgName.src = img_fehl[0].src;
      }
   }

   function toggle_aufdecken(imgName, num)
   {
      // Nur Umschalten, wenn Button aktiv ist
      if (dialog_status == "AUFDECKEN")
	  {
         imgName.src = img_aufdecken[num].src;
      } else {
         imgName.src = img_aufdecken[0].src;
      }
   }

   function fragen_zur_lektion_initialisieren()
   {
      // bertragen der Fragen und initialisierung der Arrays
      // je nach Parameter werden dabei nur Fragen bertragen, 
      // die auch auf Prfungsbgen vorkommen.
      
      if (parent.NaviFrame.UEB_PRUEF_FRAGEN_ONLY == 1)
      {
         uebung_anz_fragen = 0;
         for (i=akt_teil_von; i <= akt_teil_bis; i++)
         {
            if (parent.NaviFrame.UEB_PRUEF_FRAGEN.indexOf(i) >= 0)
            {
               // Frage tauch auf irgendeinem Prfungsbogen auf
               uebung_anz_fragen++;
               uebung_frage_nr[uebung_anz_fragen]           = i;
               uebung_frage_lektion[uebung_anz_fragen]      = parent.NaviFrame.UEBUNGS_INDEX;
               uebung_frage_anz_gestellt[uebung_anz_fragen] = 0;
               uebung_frage_anz_richtig[uebung_anz_fragen]  = 0;
            }
         }
         uebung_fragen_offen = uebung_anz_fragen;
      } else {
         // einfach alle Fragen bertragen...
         uebung_anz_fragen   = akt_teil_bis - akt_teil_von + 1;
         uebung_fragen_offen = uebung_anz_fragen;

         for (i=1; i <= uebung_anz_fragen; ++i)
         {
            uebung_frage_nr[i]           = akt_teil_von + i - 1;
            uebung_frage_lektion[i]      = parent.NaviFrame.UEBUNGS_INDEX;
            uebung_frage_anz_gestellt[i] = 0;
            uebung_frage_anz_richtig[i]  = 0;
         }
      }
   }

   function verbleibende_fragen_mischen()
   {
      // Jetzt Mischen der restlichen noch nicht abgehakten Fragen.
      for (i=1; i < uebung_fragen_offen; i++)
      {
         var ix = i + Math.round(Math.random() * (uebung_fragen_offen - i));

         // Tauschen zwischen i und ix
         uebungsdaten_swap(i, ix);
      }
   }

   function uebungsdaten_swap(ix1, ix2)
   {

      var h_nr                        = uebung_frage_nr[ix1];
      var h_gestellt                  = uebung_frage_anz_gestellt[ix1];
      var h_richtig                   = uebung_frage_anz_richtig[ix1];
      var h_lektion                   = uebung_frage_lektion[ix1];

      uebung_frage_nr[ix1]            = uebung_frage_nr[ix2];
      uebung_frage_anz_gestellt[ix1]  = uebung_frage_anz_gestellt[ix2];
      uebung_frage_anz_richtig[ix1]   = uebung_frage_anz_richtig[ix2];
      uebung_frage_lektion[ix1]       = uebung_frage_lektion[ix2];

      uebung_frage_nr[ix2]            = h_nr;
      uebung_frage_anz_gestellt[ix2]  = h_gestellt;
      uebung_frage_anz_richtig[ix2]   = h_richtig;
      uebung_frage_lektion[ix2]       = h_lektion;
   }


   function akt_frage_html()
   {
        h = "0000" + uebung_frage_nr[akt_frage];
   		return "../fa/t" + h.substr(h.length - 4,4) + "f.html";
   }

   function akt_antwort_html()
   {
        h = "0000" + uebung_frage_nr[akt_frage];
   		return "../fa/t" + h.substr(h.length - 4,4) + "a.html";
   }

   function akt_frage_lektion()
   {
   		return parent.NaviFrame.UEB_NAME[uebung_frage_lektion[akt_frage]];
   }

   function frage_stellen(img_aufdecken)
   {
      dialog_status = "AUFDECKEN";
//alert("prfe img_aufecken="+img_aufdecken);
      if (!img_aufdecken)
      { 
         // Keine Aktion, da nicht defniert...
      } else {
          // wird nur ausgefhrt, wenn es nicht aus der Initialisierung
          // heraus aufgerufen wurde, da da die Imgs noch nicht bekannt sind!
//alert("toggle_aufecken"+img_aufdecken);
          toggle_aufdecken(img_aufdecken,1);
      }

      akt_frage++;

      // Erhhen des Zhlers, wie auf diese Frage gestellt wurde.
      uebung_frage_anz_gestellt[akt_frage]++;

      // Dokument mit Frage sowie Pausenbild anzeigen...
      if (parent.NaviFrame.UEBUNGS_INDEX == 99)
      {
      	// Da die Prfungsfragen aus verschiedenen Kategorien kommen,
      	// wird die jeweils zugehrige Kategorie angezeigt.
      	parent.NaviFrame.AKTUELLE_KATEGORIE = akt_frage_lektion();
      } else {
         parent.NaviFrame.AKTUELLE_KATEGORIE = "";
      }
      parent.FrageFrame.location.href     = akt_frage_html();
      parent.AntwortFrame.location.href   = "nachdenken.html";
   }

   function antwort_aufdecken(img_aufdecken, img_richtig, img_richtig2, img_falsch)
   {
      if (dialog_status == "AUFDECKEN")
      {
         /* Neuer Dialogstatus.. jetzt kommt die Auswertung */
         dialog_status = "AUSWERTEN";

         /* Aufdecken ausblenden, Antworten einblenden */
         toggle_aufdecken(img_aufdecken,0);
         toggle_ok(img_richtig,1);
         toggle_ok2(img_richtig2,1);
         toggle_fehl(img_falsch,1);

			/* Optionale Textantwort des Anwenders beim NaviFrame speichern */
			antworttext = parent.AntwortFrame.document.anwendereingabe.antworttext.value;
			parent.NaviFrame.ANWENDER_TEXTANTWORT = antworttext;

//			alert("Textantwort:"+antworttext);

			parent.AntwortFrame.location.href = akt_antwort_html();

      }
   }

   function bewertung(antwort_richtig, img_aufdecken, img_richtig, img_richtig2, img_falsch)
   {
      if (dialog_status == "AUSWERTEN")
      {
         nicht_mehr_fragen = 0;

         // 2 bedeutet: Antwort richtig, aber nicht mehr fragen...
         if (antwort_richtig == 2)
         {
            antwort_richtig = 1;
            nicht_mehr_fragen = 1;
         }

         // Antwortmglichekeiten ausblenden
         toggle_ok(img_richtig,0);
         toggle_ok2(img_richtig2,0);
         toggle_fehl(img_falsch,0);

         // weiterleiten des Ergebnisses an die Statistik...
         parent.NaviFrame.statistik_update(uebung_frage_nr[akt_frage], antwort_richtig);

         // Auswerten der Antwort:
         if (antwort_richtig)
         {
            uebung_frage_anz_richtig[akt_frage]++;

            // Falls die Frage oft genug richtig beantwortet wurde,
            // wird sie ans Ende gestellt, so dass die folgenden eins aufrcken...
            // Ebenfalls, falls nicht-mehr-fragen gefordert wird...
            if ((uebung_frage_anz_richtig[akt_frage] == anz_richtige_zum_abhaken) |
                (nicht_mehr_fragen == 1))
            {
               for (i=akt_frage; i < uebung_fragen_offen; i++)
               {
                  uebungsdaten_swap(i, i+1);
               }
               // Anzahl offene Fragen veringern
               uebung_fragen_offen--;

               // Index der aktuellen Frage verringern, da ja die neue Frage
               // auf die aktuelle Position gerutscht ist!
               akt_frage--;

               // Falls jetzt keine Frage mehr offen ist (also n mal richtig
               // beantwortet wurde, ist der ganze Zauber vorbei.
               if (uebung_fragen_offen == 0)
               {
                  if (anz_richtige_zum_abhaken > 1 && parent.NaviFrame.UEB_ANZ_RICHTIGE_IN_FOLGE)
			      {
			         h = "hintereinander ";
			      } else {
			         h = "";
			      }

                  alert("Alle Fragen wurden " + anz_richtige_zum_abhaken + " mal " + h + "richtig beantwortet.\n" +
                     "Die bung ist damit abgeschlossen.");
                  // Buttons ausblenden...
                  parent.SteuerFrame.location.href = "about.html";
                  parent.TitelFrame.location.href  = "../titel.html";
                  parent.NaviFrame.UEBUNGS_INDEX   = 0;
               }

            }
         } else {
            // Antwort war falsch: Richtigzhler zurcksetzen, wenn die richtigen Antworten
            // aufeinander folgend gegeben werden mssen.
            if (parent.NaviFrame.UEB_ANZ_RICHTIGE_IN_FOLGE)
            {
               uebung_frage_anz_richtig[akt_frage]=0;
            }
         }

         if (akt_frage == uebung_fragen_offen && uebung_fragen_offen > 0)
         {
            alert("Aktueller Durchlauf von '" + akt_teil_name + "' ist beendet.\n" +
                  "Ein neuer Durchlauf beginnt, da " +  uebung_fragen_offen +" Frage(n) \nnoch nicht " +
                  anz_richtige_zum_abhaken + " mal hintereinander richtig beantwortet wurden.");
            if (parent.NaviFrame.UEB_FRAGEN_MISCHEN)
            {
               verbleibende_fragen_mischen();
            }
            akt_frage = 0;
         }

         // Nchste Frage wird automatisch gestellt (sofern noch vorhanden!)
         if (uebung_fragen_offen > 0)
         {
            frage_stellen(img_aufdecken);
         }
      }
   }

 function fragen_initialisieren(uebung_anz_fragen)
 {
   // lokale Variablen:
   var i=0;
   var frage=0;
   var ueb=0;
   var ueb_found=0;


   // Initialisiert die Zhle und ermittelt die Kategorie zu den Fragen

   for (i = 1; i <= uebung_anz_fragen; i++)
   {
      frage                        = uebung_frage_nr[i];
      uebung_frage_anz_gestellt[i] = 0;
      uebung_frage_anz_richtig[i]  = 0;

      // Ermitteln der bung zu der die Frage gehrt
      for (ueb = 1; ueb <= parent.NaviFrame.UEB_NR_VON.length - 1; ueb++)
      {
         if ((frage >= parent.NaviFrame.UEB_NR_VON[ueb]) &
            (frage <= parent.NaviFrame.UEB_NR_BIS[ueb]))
         {
            ueb_found = ueb; // index merken
            ueb       = parent.NaviFrame.UEB_NR_VON.length; // raus
         }
      }
      uebung_frage_lektion[i]      = ueb_found;      
   }
   
   // Setzen des Zhlers fr offene Fragen
   uebung_fragen_offen = uebung_anz_fragen;
   }

function zufallsnummer(max)
{
   var res =  1 + Math.floor(Math.random() * max);

   if (res < 1) alert("res=" + res);
   if (res > max) alert("res="+res);
   return res
}

